---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: include/TGUI/Layout.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_380f920385a16f176be7632160138052.html">TGUI</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Layout.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// TGUI - Texus&#39;s Graphical User Interface</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// Copyright (C) 2012-2017 Bruno Van de Velde (vdv_b@tgui.eu)</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// This software is provided &#39;as-is&#39;, without any express or implied warranty.</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// In no event will the authors be held liable for any damages arising from the use of this software.</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// Permission is granted to anyone to use this software for any purpose,</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// including commercial applications, and to alter it and redistribute it freely,</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// subject to the following restrictions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// 1. The origin of this software must not be misrepresented;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//    you must not claim that you wrote the original software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//    If you use this software in a product, an acknowledgment</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//    in the product documentation would be appreciated but is not required.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// 2. Altered source versions must be plainly marked as such,</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//    and must not be misrepresented as being the original software.</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// 3. This notice may not be removed or altered from any source distribution.</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifndef TGUI_LAYOUT_HPP</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define TGUI_LAYOUT_HPP</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;SFML/System/Vector2.hpp&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;TGUI/Config.hpp&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;set&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacetgui.html">tgui</a></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;{</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">class </span>Gui;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">class </span>Widget;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keyword">class </span>Layout;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">class </span>TGUI_API LayoutImpl : <span class="keyword">public</span> std::enable_shared_from_this&lt;LayoutImpl&gt;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    {</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keyword">enum class</span> Operation</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        {</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            Value,</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            String,</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            Plus,</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            Minus,</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            Multiplies,</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            Divides,</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            Modulus,</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            And,</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            Or,</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            LessThan,</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;            LessOrEqual,</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            GreaterThan,</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            GreaterOrEqual,</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;            Equal,</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            NotEqual,</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;            Minimum,</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            Maximum,</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            Conditional</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        };</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        ~LayoutImpl();</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keywordtype">void</span> recalculate();</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="comment">// Calculate the value of a layout defined by a string</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="keywordtype">float</span> parseLayoutString(std::string expression);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="comment">// Parse references to widgets from the layout strings</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keywordtype">float</span> parseWidgetName(<span class="keyword">const</span> std::string&amp; expression, Widget* widget, <span class="keyword">const</span> std::string&amp; alreadyParsedPart = <span class="stringliteral">&quot;&quot;</span>);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keywordtype">float</span> value = 0; </div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        std::set&lt;Layout*&gt; attachedLayouts; </div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        std::set&lt;LayoutImpl*&gt; parents; </div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        Operation operation = Operation::Value; </div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        std::vector&lt;std::shared_ptr&lt;LayoutImpl&gt;&gt; operands; </div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="comment">// These members are only used when operation == Operation::String</span></div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        std::string stringExpression; </div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        Widget* parentWidget = <span class="keyword">nullptr</span>; </div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        std::set&lt;std::string&gt; boundCallbacks;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    };</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno"><a class="line" href="classtgui_1_1Layout.html">  120</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    {</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a>();</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        template &lt;typename T, typename = typename std::enable_if&lt;std::is_arithmetic&lt;T&gt;::value, T&gt;::type&gt;</div><div class="line"><a name="l00138"></a><span class="lineno"><a class="line" href="classtgui_1_1Layout.html#aa460f3a9bb8054a1d9ad30ac26360832">  138</a></span>&#160;        <a class="code" href="classtgui_1_1Layout.html#aa460f3a9bb8054a1d9ad30ac26360832">Layout</a>(T constant)</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        {</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            m_impl-&gt;value = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>(constant);</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        }</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* expression);</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a>(<span class="keyword">const</span> std::string&amp; expression);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a>(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Layout.html">Layout</a>&amp; copy);</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Layout.html">Layout</a>&amp; right);</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        <span class="keywordtype">float</span> getValue() <span class="keyword">const</span>;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keywordtype">void</span> connectUpdateCallback(<span class="keyword">const</span> std::function&lt;<span class="keywordtype">void</span>()&gt;&amp; callbackFunction);</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <span class="keywordtype">void</span> update() <span class="keyword">const</span>;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        std::shared_ptr&lt;LayoutImpl&gt; getImpl() <span class="keyword">const</span>;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a32b501da6b5ac8ada43fa4c11fe7941e">operator+</a>();</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#aae4a39594b2a391929c14af31decae3e">operator-</a>();</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a> operator+=(<a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a> operator-=(<a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a> operator*=(<a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a> operator/=(<a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a> operator%=(<a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        std::shared_ptr&lt;LayoutImpl&gt; m_impl = std::make_shared&lt;LayoutImpl&gt;();</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        std::function&lt;void()&gt; m_callbackFunction;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    };</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;</div><div class="line"><a name="l00254"></a><span class="lineno"><a class="line" href="classtgui_1_1Layout2d.html">  254</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a></div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    {</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a>(sf::Vector2f constant = {0, 0});</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> layoutX, <a class="code" href="classtgui_1_1Layout.html">Layout</a> layoutY);</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        Layout2d(<span class="keyword">const</span> <span class="keywordtype">char</span>* expression);</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        Layout2d(<span class="keyword">const</span> std::string&amp; expression);</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        sf::Vector2f getValue() <span class="keyword">const</span>;</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        Layout2d <a class="code" href="namespacetgui.html#a32b501da6b5ac8ada43fa4c11fe7941e">operator+</a>();</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        Layout2d <a class="code" href="namespacetgui.html#aae4a39594b2a391929c14af31decae3e">operator-</a>();</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        Layout2d operator+=(Layout2d right);</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        Layout2d operator-=(Layout2d right);</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        Layout2d operator*=(<a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        Layout2d operator/=(<a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;        Layout2d operator%=(<a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00326"></a><span class="lineno"><a class="line" href="classtgui_1_1Layout2d.html#ac796bef9868b040cf29d52cfdc91272a">  326</a></span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="classtgui_1_1Layout2d.html#ac796bef9868b040cf29d52cfdc91272a">x</a>; </div><div class="line"><a name="l00327"></a><span class="lineno"><a class="line" href="classtgui_1_1Layout2d.html#a688431f265d7bfc45bf6272ffcef7e75">  327</a></span>&#160;        <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="classtgui_1_1Layout2d.html#a688431f265d7bfc45bf6272ffcef7e75">y</a>; </div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    };</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a8609d6744530000f82d553e84bbcf262">operator&lt;</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a7e9c29186dd9c58ed6f59524dc0d61e1">operator&lt;=</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a600fd3916fa36f08a00db77d965e468e">operator&gt;</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a1763c5a13343f86090090e504e35fa8a">operator&gt;=</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#aec58c48b53c8981c66d9d39a640709ae">operator==</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#ac195454be91b526be88c6deedb0d6722">operator!=</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a32b501da6b5ac8ada43fa4c11fe7941e">operator+</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#aae4a39594b2a391929c14af31decae3e">operator-</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a6af48451cf04f38eeaa6d7bc83192c69">operator*</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a5f9f5f93ef5d1889a74a5cd164433ba8">operator/</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#ad6178d8b7caa315efd8c4b722188d98c">operator%</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a432e7a92fc9c6a41ca0453143fe0d85b">operator&amp;&amp;</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#ab33d85cc29c3c8d4cb9302e163ab75ec">operator||</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#aec58c48b53c8981c66d9d39a640709ae">operator==</a>(<a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> left, <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> right);</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#ac195454be91b526be88c6deedb0d6722">operator!=</a>(<a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> left, <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> right);</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#a32b501da6b5ac8ada43fa4c11fe7941e">operator+</a>(<a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> left, <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> right);</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#aae4a39594b2a391929c14af31decae3e">operator-</a>(<a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> left, <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> right);</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#a6af48451cf04f38eeaa6d7bc83192c69">operator*</a>(<a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#a5f9f5f93ef5d1889a74a5cd164433ba8">operator/</a>(<a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#ad6178d8b7caa315efd8c4b722188d98c">operator%</a>(<a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> left, <a class="code" href="classtgui_1_1Layout.html">Layout</a> right);</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#a6af48451cf04f38eeaa6d7bc83192c69">operator*</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> left, <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> right);</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#aea0ae0fd5751d1245c5a050d12932778">bindLeft</a>(std::shared_ptr&lt;Widget&gt; widget);</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a87c61eb0319debb4329c140542c06446">bindTop</a>(std::shared_ptr&lt;Widget&gt; widget);</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a8fb205ef056bb9d28c370a68434fcc50">bindWidth</a>(std::shared_ptr&lt;Widget&gt; widget);</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#aac02e45df685e26d1f1c58b6d1ef3b73">bindHeight</a>(std::shared_ptr&lt;Widget&gt; widget);</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a122fa36bf819b52c7f8a250b60fcf9cf">bindRight</a>(std::shared_ptr&lt;Widget&gt; widget);</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#adbaac1043a07a0095c3ee90d6070b70b">bindBottom</a>(std::shared_ptr&lt;Widget&gt; widget);</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#aeeb273b813170e72c6999a38b6ed727a">bindPosition</a>(std::shared_ptr&lt;Widget&gt; widget);</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#a980dd88c8757152349370c5dee94ee61">bindSize</a>(std::shared_ptr&lt;Widget&gt; widget);</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#aea0ae0fd5751d1245c5a050d12932778">bindLeft</a>(<a class="code" href="classtgui_1_1Gui.html">Gui</a>&amp; gui);</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a87c61eb0319debb4329c140542c06446">bindTop</a>(<a class="code" href="classtgui_1_1Gui.html">Gui</a>&amp; gui);</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a8fb205ef056bb9d28c370a68434fcc50">bindWidth</a>(<a class="code" href="classtgui_1_1Gui.html">Gui</a>&amp; gui);</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#aac02e45df685e26d1f1c58b6d1ef3b73">bindHeight</a>(<a class="code" href="classtgui_1_1Gui.html">Gui</a>&amp; gui);</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a122fa36bf819b52c7f8a250b60fcf9cf">bindRight</a>(<a class="code" href="classtgui_1_1Gui.html">Gui</a>&amp; gui);</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#adbaac1043a07a0095c3ee90d6070b70b">bindBottom</a>(<a class="code" href="classtgui_1_1Gui.html">Gui</a>&amp; gui);</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#aeeb273b813170e72c6999a38b6ed727a">bindPosition</a>(<a class="code" href="classtgui_1_1Gui.html">Gui</a>&amp; gui);</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#a980dd88c8757152349370c5dee94ee61">bindSize</a>(<a class="code" href="classtgui_1_1Gui.html">Gui</a>&amp; gui);</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;</div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#ac7f577024c76243c959fbce9c4610136">bindMin</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> value1, <a class="code" href="classtgui_1_1Layout.html">Layout</a> value2);</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a60c0a0c8861dfa50f18be6dd5446d643">bindMax</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> value1, <a class="code" href="classtgui_1_1Layout.html">Layout</a> value2);</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#abb9b73ff06b2fb66f2fb5550c64b5c6f">bindRange</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> minimum, <a class="code" href="classtgui_1_1Layout.html">Layout</a> maximum, <a class="code" href="classtgui_1_1Layout.html">Layout</a> value);</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a7354263149700e8f0deb653c40853f89">bindIf</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> condition, <a class="code" href="classtgui_1_1Layout.html">Layout</a> trueExpr, <a class="code" href="classtgui_1_1Layout.html">Layout</a> falseExpr);</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#a7354263149700e8f0deb653c40853f89">bindIf</a>(<a class="code" href="classtgui_1_1Layout.html">Layout</a> condition, <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> trueExpr, <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> falseExpr);</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a9f0fa1db51b03ef38398ac9124b93365">bindStr</a>(<span class="keyword">const</span> std::string&amp; expression);</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout.html">Layout</a> <a class="code" href="namespacetgui.html#a9f0fa1db51b03ef38398ac9124b93365">bindStr</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* expression);</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#a6733d3b6d3aa6328a0c47ab0b17b36e2">bindStr2d</a>(<span class="keyword">const</span> std::string&amp; expression);</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;    TGUI_API <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a> <a class="code" href="namespacetgui.html#a6733d3b6d3aa6328a0c47ab0b17b36e2">bindStr2d</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* expression);</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;    <span class="comment">// Put TGUI_IMPORT_LAYOUT_BIND_FUNCTIONS somewhere in your code to no longer have to put &quot;tgui::&quot; in front of the bind functions</span></div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;    <span class="comment">// without having to import everything from tgui in your namespace or writing all these using statements yourself.</span></div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;<span class="preprocessor">    #define TGUI_IMPORT_LAYOUT_BIND_FUNCTIONS \</span></div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;<span class="preprocessor">        using tgui::bindLeft; \</span></div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;<span class="preprocessor">        using tgui::bindTop; \</span></div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;<span class="preprocessor">        using tgui::bindWidth; \</span></div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;<span class="preprocessor">        using tgui::bindHeight; \</span></div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;<span class="preprocessor">        using tgui::bindRight; \</span></div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;<span class="preprocessor">        using tgui::bindBottom; \</span></div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;<span class="preprocessor">        using tgui::bindPosition; \</span></div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;<span class="preprocessor">        using tgui::bindSize; \</span></div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;<span class="preprocessor">        using tgui::bindMin; \</span></div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;<span class="preprocessor">        using tgui::bindMax; \</span></div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;<span class="preprocessor">        using tgui::bindRange; \</span></div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;<span class="preprocessor">        using tgui::bindIf; \</span></div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;<span class="preprocessor">        using tgui::bindStr; \</span></div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;<span class="preprocessor">        using tgui::bindStr2d;</span></div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;}</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;<span class="preprocessor">#endif // TGUI_LAYOUT_HPP</span></div><div class="ttc" id="namespacetgui_html"><div class="ttname"><a href="namespacetgui.html">tgui</a></div><div class="ttdoc">Namespace that contains all TGUI functions and classes. </div><div class="ttdef"><b>Definition:</b> Animation.hpp:33</div></div>
<div class="ttc" id="namespacetgui_html_a87c61eb0319debb4329c140542c06446"><div class="ttname"><a href="namespacetgui.html#a87c61eb0319debb4329c140542c06446">tgui::bindTop</a></div><div class="ttdeci">TGUI_API Layout bindTop(std::shared_ptr&lt; Widget &gt; widget)</div><div class="ttdoc">Bind to the y position of the widget. </div></div>
<div class="ttc" id="namespacetgui_html_a6733d3b6d3aa6328a0c47ab0b17b36e2"><div class="ttname"><a href="namespacetgui.html#a6733d3b6d3aa6328a0c47ab0b17b36e2">tgui::bindStr2d</a></div><div class="ttdeci">TGUI_API Layout2d bindStr2d(const std::string &amp;expression)</div><div class="ttdoc">Bind a string for a layout (you can also just create the layout directly with the string) ...</div></div>
<div class="ttc" id="namespacetgui_html_a7354263149700e8f0deb653c40853f89"><div class="ttname"><a href="namespacetgui.html#a7354263149700e8f0deb653c40853f89">tgui::bindIf</a></div><div class="ttdeci">TGUI_API Layout bindIf(Layout condition, Layout trueExpr, Layout falseExpr)</div><div class="ttdoc">Bind conditionally to one of the two layouts. </div></div>
<div class="ttc" id="classtgui_1_1Layout2d_html"><div class="ttname"><a href="classtgui_1_1Layout2d.html">tgui::Layout2d</a></div><div class="ttdoc">Class to store the position or size of a widget. </div><div class="ttdef"><b>Definition:</b> Layout.hpp:254</div></div>
<div class="ttc" id="classtgui_1_1Gui_html"><div class="ttname"><a href="classtgui_1_1Gui.html">tgui::Gui</a></div><div class="ttdoc">Gui class. </div><div class="ttdef"><b>Definition:</b> Gui.hpp:42</div></div>
<div class="ttc" id="classtgui_1_1Layout_html_aa460f3a9bb8054a1d9ad30ac26360832"><div class="ttname"><a href="classtgui_1_1Layout.html#aa460f3a9bb8054a1d9ad30ac26360832">tgui::Layout::Layout</a></div><div class="ttdeci">Layout(T constant)</div><div class="ttdoc">Constructor to implicitly construct from numeric constant. </div><div class="ttdef"><b>Definition:</b> Layout.hpp:138</div></div>
<div class="ttc" id="namespacetgui_html_a1763c5a13343f86090090e504e35fa8a"><div class="ttname"><a href="namespacetgui.html#a1763c5a13343f86090090e504e35fa8a">tgui::operator&gt;=</a></div><div class="ttdeci">TGUI_API Layout operator&gt;=(Layout left, Layout right)</div><div class="ttdoc">&gt;= operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_a7e9c29186dd9c58ed6f59524dc0d61e1"><div class="ttname"><a href="namespacetgui.html#a7e9c29186dd9c58ed6f59524dc0d61e1">tgui::operator&lt;=</a></div><div class="ttdeci">TGUI_API Layout operator&lt;=(Layout left, Layout right)</div><div class="ttdoc">&lt;= operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_a980dd88c8757152349370c5dee94ee61"><div class="ttname"><a href="namespacetgui.html#a980dd88c8757152349370c5dee94ee61">tgui::bindSize</a></div><div class="ttdeci">TGUI_API Layout2d bindSize(std::shared_ptr&lt; Widget &gt; widget)</div><div class="ttdoc">Bind to the size of the widget. </div></div>
<div class="ttc" id="namespacetgui_html_aec58c48b53c8981c66d9d39a640709ae"><div class="ttname"><a href="namespacetgui.html#aec58c48b53c8981c66d9d39a640709ae">tgui::operator==</a></div><div class="ttdeci">TGUI_API Layout operator==(Layout left, Layout right)</div><div class="ttdoc">== operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_ac7f577024c76243c959fbce9c4610136"><div class="ttname"><a href="namespacetgui.html#ac7f577024c76243c959fbce9c4610136">tgui::bindMin</a></div><div class="ttdeci">TGUI_API Layout bindMin(Layout value1, Layout value2)</div><div class="ttdoc">Bind to the minimum of two values. </div></div>
<div class="ttc" id="namespacetgui_html_a8609d6744530000f82d553e84bbcf262"><div class="ttname"><a href="namespacetgui.html#a8609d6744530000f82d553e84bbcf262">tgui::operator&lt;</a></div><div class="ttdeci">TGUI_API Layout operator&lt;(Layout left, Layout right)</div><div class="ttdoc">&lt; operator for the Layout class </div></div>
<div class="ttc" id="classtgui_1_1Layout_html"><div class="ttname"><a href="classtgui_1_1Layout.html">tgui::Layout</a></div><div class="ttdoc">Class to store the left, top, width or height of a widget. </div><div class="ttdef"><b>Definition:</b> Layout.hpp:120</div></div>
<div class="ttc" id="namespacetgui_html_a122fa36bf819b52c7f8a250b60fcf9cf"><div class="ttname"><a href="namespacetgui.html#a122fa36bf819b52c7f8a250b60fcf9cf">tgui::bindRight</a></div><div class="ttdeci">TGUI_API Layout bindRight(std::shared_ptr&lt; Widget &gt; widget)</div><div class="ttdoc">Bind to the right position of the widget. </div></div>
<div class="ttc" id="namespacetgui_html_aea0ae0fd5751d1245c5a050d12932778"><div class="ttname"><a href="namespacetgui.html#aea0ae0fd5751d1245c5a050d12932778">tgui::bindLeft</a></div><div class="ttdeci">TGUI_API Layout bindLeft(std::shared_ptr&lt; Widget &gt; widget)</div><div class="ttdoc">Bind to the x position of the widget. </div></div>
<div class="ttc" id="namespacetgui_html_ad6178d8b7caa315efd8c4b722188d98c"><div class="ttname"><a href="namespacetgui.html#ad6178d8b7caa315efd8c4b722188d98c">tgui::operator%</a></div><div class="ttdeci">TGUI_API Layout operator%(Layout left, Layout right)</div><div class="ttdoc">% operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_ab33d85cc29c3c8d4cb9302e163ab75ec"><div class="ttname"><a href="namespacetgui.html#ab33d85cc29c3c8d4cb9302e163ab75ec">tgui::operator||</a></div><div class="ttdeci">TGUI_API Layout operator||(Layout left, Layout right)</div><div class="ttdoc">|| operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_ac195454be91b526be88c6deedb0d6722"><div class="ttname"><a href="namespacetgui.html#ac195454be91b526be88c6deedb0d6722">tgui::operator!=</a></div><div class="ttdeci">TGUI_API Layout operator!=(Layout left, Layout right)</div><div class="ttdoc">!= operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_abb9b73ff06b2fb66f2fb5550c64b5c6f"><div class="ttname"><a href="namespacetgui.html#abb9b73ff06b2fb66f2fb5550c64b5c6f">tgui::bindRange</a></div><div class="ttdeci">TGUI_API Layout bindRange(Layout minimum, Layout maximum, Layout value)</div><div class="ttdoc">Bind to a value that remains between the minimum and maximum. </div></div>
<div class="ttc" id="namespacetgui_html_a6af48451cf04f38eeaa6d7bc83192c69"><div class="ttname"><a href="namespacetgui.html#a6af48451cf04f38eeaa6d7bc83192c69">tgui::operator*</a></div><div class="ttdeci">TGUI_API Layout operator*(Layout left, Layout right)</div><div class="ttdoc">operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_a60c0a0c8861dfa50f18be6dd5446d643"><div class="ttname"><a href="namespacetgui.html#a60c0a0c8861dfa50f18be6dd5446d643">tgui::bindMax</a></div><div class="ttdeci">TGUI_API Layout bindMax(Layout value1, Layout value2)</div><div class="ttdoc">Bind to the maximum of two values. </div></div>
<div class="ttc" id="namespacetgui_html_a9f0fa1db51b03ef38398ac9124b93365"><div class="ttname"><a href="namespacetgui.html#a9f0fa1db51b03ef38398ac9124b93365">tgui::bindStr</a></div><div class="ttdeci">TGUI_API Layout bindStr(const std::string &amp;expression)</div><div class="ttdoc">Bind a string for a layout (you can also just create the layout directly with the string) ...</div></div>
<div class="ttc" id="namespacetgui_html_a432e7a92fc9c6a41ca0453143fe0d85b"><div class="ttname"><a href="namespacetgui.html#a432e7a92fc9c6a41ca0453143fe0d85b">tgui::operator&amp;&amp;</a></div><div class="ttdeci">TGUI_API Layout operator&amp;&amp;(Layout left, Layout right)</div><div class="ttdoc">&amp;&amp; operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_aae4a39594b2a391929c14af31decae3e"><div class="ttname"><a href="namespacetgui.html#aae4a39594b2a391929c14af31decae3e">tgui::operator-</a></div><div class="ttdeci">TGUI_API Layout operator-(Layout left, Layout right)</div><div class="ttdoc">operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_a32b501da6b5ac8ada43fa4c11fe7941e"><div class="ttname"><a href="namespacetgui.html#a32b501da6b5ac8ada43fa4c11fe7941e">tgui::operator+</a></div><div class="ttdeci">TGUI_API Layout operator+(Layout left, Layout right)</div><div class="ttdoc">operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_a600fd3916fa36f08a00db77d965e468e"><div class="ttname"><a href="namespacetgui.html#a600fd3916fa36f08a00db77d965e468e">tgui::operator&gt;</a></div><div class="ttdeci">TGUI_API Layout operator&gt;(Layout left, Layout right)</div><div class="ttdoc">&gt; operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_a5f9f5f93ef5d1889a74a5cd164433ba8"><div class="ttname"><a href="namespacetgui.html#a5f9f5f93ef5d1889a74a5cd164433ba8">tgui::operator/</a></div><div class="ttdeci">TGUI_API Layout operator/(Layout left, Layout right)</div><div class="ttdoc">/ operator for the Layout class </div></div>
<div class="ttc" id="namespacetgui_html_aeeb273b813170e72c6999a38b6ed727a"><div class="ttname"><a href="namespacetgui.html#aeeb273b813170e72c6999a38b6ed727a">tgui::bindPosition</a></div><div class="ttdeci">TGUI_API Layout2d bindPosition(std::shared_ptr&lt; Widget &gt; widget)</div><div class="ttdoc">Bind to the position of the widget. </div></div>
<div class="ttc" id="namespacetgui_html_aac02e45df685e26d1f1c58b6d1ef3b73"><div class="ttname"><a href="namespacetgui.html#aac02e45df685e26d1f1c58b6d1ef3b73">tgui::bindHeight</a></div><div class="ttdeci">TGUI_API Layout bindHeight(std::shared_ptr&lt; Widget &gt; widget)</div><div class="ttdoc">Bind to the height of the widget. </div></div>
<div class="ttc" id="classtgui_1_1Layout2d_html_ac796bef9868b040cf29d52cfdc91272a"><div class="ttname"><a href="classtgui_1_1Layout2d.html#ac796bef9868b040cf29d52cfdc91272a">tgui::Layout2d::x</a></div><div class="ttdeci">Layout x</div><div class="ttdoc">Layout to store the x component. </div><div class="ttdef"><b>Definition:</b> Layout.hpp:326</div></div>
<div class="ttc" id="namespacetgui_html_a8fb205ef056bb9d28c370a68434fcc50"><div class="ttname"><a href="namespacetgui.html#a8fb205ef056bb9d28c370a68434fcc50">tgui::bindWidth</a></div><div class="ttdeci">TGUI_API Layout bindWidth(std::shared_ptr&lt; Widget &gt; widget)</div><div class="ttdoc">Bind to the width of the widget. </div></div>
<div class="ttc" id="namespacetgui_html_adbaac1043a07a0095c3ee90d6070b70b"><div class="ttname"><a href="namespacetgui.html#adbaac1043a07a0095c3ee90d6070b70b">tgui::bindBottom</a></div><div class="ttdeci">TGUI_API Layout bindBottom(std::shared_ptr&lt; Widget &gt; widget)</div><div class="ttdoc">Bind to the bottom of the widget. </div></div>
<div class="ttc" id="classtgui_1_1Layout2d_html_a688431f265d7bfc45bf6272ffcef7e75"><div class="ttname"><a href="classtgui_1_1Layout2d.html#a688431f265d7bfc45bf6272ffcef7e75">tgui::Layout2d::y</a></div><div class="ttdeci">Layout y</div><div class="ttdoc">Layout to store the y component. </div><div class="ttdef"><b>Definition:</b> Layout.hpp:327</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:40 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
